#!/usr/bin/perl -w
# plotsat7    plotte GPS-Satelliten aus Log von GPSd mit SNR bzw. Doppler ->  Grauskala oder Farbskala
# fr modifizierten driver_tsip.c
# Trimble Thunderbolt manual: Azimuth Angle: The angle of the line-of-sight vector (to satellite),
# projected on the horizontal plane, measured clockwise from true North.
# Datei abgeleitet von plot9ik.pl

# default input file is 'outfile', may be superseded by -ffilename flag


use English;
#use strict;
use Tk;

# predeclare global subroutines
sub display_coordinates;
sub procfiles;	# sat
#sub mkcolor;    # int-> color for -fill

my $grey = 1;		# for mkcolor: 1=grey 0=color for trace color depending on satellite SNR or Doppler
my $ke =  0;		# for flag Kessel+Temperatur wanted
my $he = 0;		# for flag Helligkeit 
my $interv = 40;	# Dickenmassstab   Dicke = SNR/$interv
my $f = 'outfile';	# filename input with default value, may be superseded by -ffilename flag
my $Dopsel = 1;		# Select Doppler = 1, Signal level = 0 ( -s).

my($day) = "  ";
my($lhx) = 0;		# last x coordinate where hour was printed
my($lhxd) = 0;		# last x coordinate where day.month was printed
my $kesselAn = 1;			# = 0 wenn Kessel abgeschaltet

my $scrollregi = 600 ;	# total scroll region. Across this region we may scroll.


my($fElr, $fAzr);			# elevation and azimuth in radian
my($iPRN) = -1;			# sat number
my($x0) = 250;			# center of coordinate system
my($y0) = 250;
my($fd2r) = 3.1415265/180;		# conversion from degrees to radian
my($m) = 250	;			# Massstab
my $start1 = 1;				# start phase ->1, afterwards 0
my @towday = ('SUN','Mon','Tue','Wed','Thu','Fri','Sat');	# day for trimble TOW time of week day
my @mass1 = ('0','2','4','6','8','10','12','14','16','18','20','22','24','26','28','30','32','34','36','38','40','42','44','46','48','50','52','54','56','58','60');

my @mass2 = ('4.5','4.2','3.9','3.6','3.3','3','2.7','2.4','2.1','1.8','1.5','1.2','.9','.6','.3','0','.3','.6','.9','1.2','1.5','1.8','2.1','2.4','2.7','3','3.3','3.6','3.9','4.2','4.5');


# ---------------------flag handling
while ($_ = $ARGV[0], /^-/ ) {
	shift;
	last if /^--$/;
	{
	 #if (/(.*)/) { print 'Anfang=', $1, "\n" }
	 #if (/^-k/) { $ke = 1; last }
	 #if (/^-h/) { $he = 1; last }
	 #if (/^-i$/) {  print "i leer\n"; shift; $i = $_ ; last }
	 #if (/^-i(\d*)/) { print "i num\n"; $i = $1; last }
	 if (/^-i(\d*)/) { $interv = $1; last }
	 #if (/^-i (\d*)/) { print "i num2\n"; $i = $1; last }
	 if (/^-s/) { $Dopsel = 0; last }			# select signal level trace coloring
	 if (/^-f(.*)/) { $f = $1; last }			# filename direkt hinter -f ohne Zwischenraum
	 if (/^-c/) { $grey = 0; last  }			# schaltet um auf color
	 if (/(.*)/) { print 'Zusatz=', $1, " ??\n"; last }
	 }
}


             
if ($interv < 1 or $interv > 60 ) { $interv = 60 };		# default interval = 60 minutes            
# --------------------             



my $p = 0;		# print internals if true
my @zeit = (-1, -1, -1, -1, -1, -1 );				
					# aktuell bearbeiteter Zeitpunkt bzw. Intervall @zeit .. @zeit + $interv
								# zeit[0]=Jahr zB.2007, zeit[1]=Monat 0-12, zeit[2]=Tag, 
									# zeit[3]=Stunde, zeit[4]=Minute, zeit[5]= Sekunde
my @zeiti = (-1, -1, -1, -1, -1, -1 );				
					# aktuelles Intervall @zeiti .. @zeiti + $interv
my @startzeit = 		(-1, -1, -1, -1, -1, -1 );	
									# Zeit, mit der das Diagramm links anfaengt
my $type1 = -1;					# Type des gerade bearbeiteten Messwertes
#						1=Kessel, 2=Temp aussen Nord, 3=Temp aussen Sd,
#						4=Winterg30cm, 5=Winterg2m, 6=Wohnzi1
my $wert1 = 0;									# aktueller Wert
my @wert = ( 0,0,0,0,0,0,0 );		# Messwert-Summe im Intervall. Index dazu ist $type1
my @zahl = ( 0,0,0,0,0,0,0 );		# Messwert-Anzahl fr Mittelwertbildung ber das Intervall
my @farbe = ( 'yellow', 'black', 'blue', 'red', 'magenta', 'green', 'brown' ); #line color
my $il = 0;							# Laufindex
my @newx = ( 0,0,0,0,0,0,0 );		# X-Koordinate fr Plot
my @newy = ( 0,0,0,0,0,0,0 );		# Y-Koordinate
my @oldx = (-1, -1, -1, -1, -1, -1, -1 );					# voriger Wert X
my @oldy = ( 351, 351, 351, 351, 351, 351, 351);	# voriger Wert Y
my %monat = ( 'Jan', 1, 'Feb', 2, 'Mar', 3, 'Apr', 4, 'May', 5, 'Jun', 6, 'Jul', 7, 
							'Aug', 8, 'Sep', 9, 'Oct', 10, 'Nov', 11, 'Dec', 12 );
my @montt = ( 1, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
my($o, $s) = (250, 20);
my($pi, $x, $y) = (3.1415926, 0);
my $dcmode = 0;  	# display_coordinates modus
my $scrb = 0;		# aktuelle scroll-Position
my $co;     		# fr color 
my $PRN = 0;		# PRN Satelliten-Nummer
my $fDop = 0;		# Doppler-Frequenzabweichung float
my @Dop = ( 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 );	# Doppler for all Satellites	


my $mw = MainWindow->new;

# Skalen-Canvas
#my $fr = $mw->Frame( -borderwidth => 5 )->pack( -side => 'left' );
#my $cs = $fr->Canvas( -width => 37 , -height => 500);
#$cs->pack();
print " wait a moment for processing the graphics \n";
 
#  Canvas for Graph
my $grid = $mw->Frame(      )->pack( -side => 'right' );

my $c = $grid->Canvas(
# begrenzt die Verschiebung horizontal
                          -scrollregion => [  0, 0, $scrollregi, 500 ],   # noetig fuer fraction
                          -width => 600, -height => 600);
$c->pack( -side => 'right');
$c->Tk::bind('<Button-1>' => \&display_coordinates);

#    my $scroll = $mw->Scrollbar(
#                          -orient => 'horizontal',
#                          -command => [ 'xview', $c ],
                          #-width =>  10,			# Groesse des Scrollbars
                          #-height => 10,			bad option
                          #-trough1 => 10,
                          #-trough2 => 10    #bad option
                          #-command => [ 'xview', $c, print "sxview= $c->xview \n" ]		liefert Tk callback error: unknown option 1. must be moveto or scroll at vendor_perl/5.8/cygwin/Tk.pm
                          # -command => [ print "xview =", 'xview', "\n" ]
#                                );

#    $c->configure(
#    											-relief => 'sunken',
#    											-borderwidth => 2,
#    											-scrollregion => [-11, -11, 1500, 500], #begrenzt Scroll
#                         -trough1 => 10,		#..bad option
#                         -trough2 => 10,
													#-width => 30,		macht das Fenster ganz schmal
#                          -xscrollcommand => [ 'set', $scroll ]
#                                     );

#    $scroll->pack(-side => 'bottom',
#              -fill =>  'x',
              #-trough1 => 10,		bad option
#             );

  	#print "scrollGet= $scroll->get \n";           
  #print "c= $c \n";														# c= Tk::Canvas=HASH(0x102e9878)         
	#print "scroll=", %$scroll, "\n";
	#my %scroll1 = %$scroll;
		
	#print "scroll2= $$scroll{_TkValue_} \n";		 outputs scroll2= .scrollbar
	#my $scroll2a = \$$scroll{_TkValue_};
	#print "scroll2a= ref($scroll2a) \n";				 ref(SCALAR(0x1034cd5c))
	
	#print "scroll3= %$$scroll{_TkValue_} \n";		 outputs scroll3= %.scrollbar
	#while (($key,$value) = each %scroll1)  {
	#print "$key=$value\n";   #};
	# Ausgabe: _TkValue_=.scrollbar
	

# nun ein paar Buttons
# my $button1 =  $mw->Button( 
#                             	-text => 'T',
#                            	-command => sub { $dcmode = 0; print "Knopf T\n" ;  }
#                           );
                           
# my $button2 =  $mw->Button( 
#                             	-text => 'P',
#                            	-command => sub { $dcmode = 1; print "Knopf P\n" ;  }
#                           );
                           
# $button1->pack(-side => 'bottom' );
				# , -fill => 'x', -pady => '2m' ); 
# $button2->pack(-side => 'bottom' );

$c->createText( 55, 10 , -fill => 'black', -text => "input file = $f" );

# Nullinie auf dem Scroll-Canvas
$c->createLine(0, 250, 500, 250);


for ($il = 0; $il < 31; $il++)                # make color bar
{
	$c->createLine(10+18*$il, 550, 10+18*($il+1), 550, -fill => mkcolor($il), -width => 10 );
        $c->createLine(10+18*$il, 555, 10+18*$il, 565, -fill => 'black' );
	if ( $Dopsel ) {
        	$c->createText( 18+18*$il, 570 , -fill => 'black', -text => $mass2[$il] ); 
	} else {
		$c->createText( 18+18*$il, 570 , -fill => 'black', -text => $mass1[$il] ); 
	}
}
 $c->createLine(10+31*18, 555, 10+31*18, 565, -fill => 'black' );
 if ( $Dopsel ) {
 	$c->createText( 250, 580 , -fill => 'black', -text => '-  Minus     Doppler frequency difference in kHz     Plus  +' );
 } else {
 	$c->createText( 250, 580 , -fill => 'black', -text => 'Signal Level in db' );
 }

 procfiles() ;		# plot Satellites


MainLoop;


# --------------------------------------------------
# mkcolor: sub makes transformation from integer to RGB gray or grey value depending on $grey for fill parameter
# generate RGB 3x8bit color value for fill parameter 
# rainbow color for input values from 0 to 30
# input     output color
#    0				red
#    1				14/15 red with 1/15 green 
#   14				1/15 red with 14/15 green 
#   15				green
#   16				14/15 green with 1/15 blue
#   29				1/15 green with 14/15 blue
#   30				blue
sub mkcolor {
	my @hexi = ('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');
	my $in; my $out; my $in2;
	$in = $_[0]; $in2 = $in/2;
	if ( $in < 0 )  { print "mkcolor In = $in\n"; $in = 0 };
	if ( $in > 30 ) { print "mkcolor In = $in\n"; $in = 30 };
	
	if ( $grey ) {
	   if ( (($in / 2) * 2) == $in )		# gerade Zahl
	   {
		        #       Red        Green    Blue
	     $out = '#'.$hexi[$in2].'0'.$hexi[$in2].'0'.$hexi[$in2].'0';
	   }
	   else					# ungerade Zahl
	   {
		    #   Red      Green        Blue
	      $out = '#'.$hexi[$in2].'8'.$hexi[$in2].'8'.$hexi[$in2].'8';
	   }
	}		# end if $grey
	else
	{			# not grey but color
   	   if ( $in < 16 )
	   {
		        #       Red        Green    Blue
	     $out = '#'.$hexi[15-$in].$hexi[$in].'0';
	   }
	   if ($in >15 )
	   {
		    #   Red      Green        Blue
		$out = '#0'.$hexi[30-$in].$hexi[$in-15] ;
	   }
	}		# end else (not grey)
 $out;
}
# --------------------------------------------------
# display_coordinates:  Hiermit sollen Punkte im Diagramm markiert werden,
# deren Koordinaten ausgegeben werden.
# Wird mit linkem Mausklick gestartet

sub display_coordinates {
    # Print Canvas and Plot coordinates.
    my($canvas) = @ARG;
    my $e = $canvas->XEvent;
    my($Az, $El) =  1 , 1 ;
    my $canv_x = $e->x; 
    my $canv_y = $e->y; 
    my ($xn , $yn);

    $xn = ( $canv_x - $x0)/$m;	#normalisierte Nullp.koord.
    $yn = (-$canv_y + $y0)/$m;
    
    $El = int(90*( 1 - sqrt( $xn*$xn+$yn*$yn )));
    $Az = int( -(180/3.141592)*atan2( $yn, $xn ) );
    if ( $Az < 0 ) { $Az = 360 + $Az };
	

	$c->createLine( $canv_x-4+$scrb, $canv_y, $canv_x+4+$scrb, $canv_y);  # mache Kreuz
	$c->createLine( $canv_x+$scrb, $canv_y-4, $canv_x+$scrb, $canv_y+4);
	$c->createText( $canv_x+$scrb, $canv_y-10, -fill =>'black', 
            -text  => ' Az=' . $Az . ' , El=' . $El . '' ,
            -justify => 'right'
            );		
    

} # end display_coordinates

# --------------------------------------------------

#					SUB plot Satellitengraphik
sub procfiles {
   my($i, $j, $h, $hl) = 0;
   my($lx) = 500;		# coordinates from last point
   my($ly) = 250;
   my($cx, $cy) = 0;	# coordinates from current point
   my($fSNR, $fEl, $fAz) = -1;		# signal to noise ratio, elevation in degrees, azimuth in degrees
   my($fElr, $fAzr);			# elevation and azimuth in radian
   my($iPRN) = -1;			# sat number
   my($x0) = 250;			# center of coordinate system
   my($y0) = 250;
   my($fd2r) = 3.1415265/180;		# conversion from degrees to radian
   my($m) = 250	;			# Massstab
   my($b) = 0;				# boolean volle Stunde +0..5sek

   $j = 0; $hl = 0;
   open(FH1, $f ) or die "can't open $f : $!\n";
   #print "file $f opened\n";

   $c->createLine( $x0, 0, $x0, 500 , -fill => 'black', -width => 1 );		# vertikale Ost-West-Linie

   for ( $i=0 ; $i<365 ; $i = $i + 10 )		# KREIS FR Elevation = 0 ziehen
   {
	$cx = $x0 + $m*cos(-$i*$fd2r);	# Koordinaten aus Azimuth ausrechnen
	$cy = $y0 - $m*sin(-$i*$fd2r);
	$c->createLine( $lx, $ly, $cx, $cy , -fill => 'black', -width => 1 );
	$lx = $cx;
	$ly = $cy;
   } 
	# Himmelsrichtungen
   $c->createText( $x0 + $m + 10, $y0 , -fill => 'black', -text => 'N' ); 
   $c->createText( 10 , $y0 , -fill => 'black', -text => 'S' ); 
   $c->createText( $x0 , $y0 + $m - 10 , -fill => 'black', -text => 'O' ); 
   $c->createText( $x0 , 10 , -fill => 'black', -text => 'W' ); 
	# Elevationsskala
   $c->createText(2*$x0-$m*30/90, $y0-35, -fill => 'blue', -text => 'Elevation');
   $c->createLine($m+$x0-$m*10/90, $y0-5, $m+$x0-$m*10/90, $y0+5);
   $c->createText(2*$x0-$m*10/90+5, $y0-15, -fill => 'blue', -text => '10');
   $c->createLine($m+$x0-$m*20/90, $y0-5, $m+$x0-$m*20/90, $y0+5);
   $c->createText(2*$x0-$m*20/90+5, $y0-15, -fill => 'blue', -text => '20');
   $c->createLine($m+$x0-$m*30/90, $y0-5, $m+$x0-$m*30/90, $y0+5);
   $c->createText(2*$x0-$m*30/90+5, $y0-15, -fill => 'blue', -text => '30');
   $c->createLine($m+$x0-$m*40/90, $y0-5, $m+$x0-$m*40/90, $y0+5);
   $c->createText(2*$x0-$m*40/90+5, $y0-15, -fill => 'blue', -text => '40');
   $c->createLine($m+$x0-$m*50/90, $y0-5, $m+$x0-$m*50/90, $y0+5);
   $c->createText(2*$x0-$m*50/90+5, $y0-15, -fill => 'blue', -text => '50');
   $c->createLine($m+$x0-$m*60/90, $y0-5, $m+$x0-$m*60/90, $y0+5);
   $c->createText(2*$x0-$m*60/90+5, $y0-15, -fill => 'blue', -text => '60');
   $c->createLine($m+$x0-$m*70/90, $y0-5, $m+$x0-$m*70/90, $y0+5);
   $c->createText(2*$x0-$m*70/90+5, $y0-15, -fill => 'blue', -text => '70');
   $c->createLine($m+$x0-$m*80/90, $y0-5, $m+$x0-$m*80/90, $y0+5);
   $c->createText(2*$x0-$m*80/90+5, $y0-15, -fill => 'blue', -text => '80');
   $c->createText(2*$x0-$m*40/90, $y0+25, -fill => 'red', -text => 'Die PRN-Nummer steht in rot');
   $c->createText(2*$x0-$m*40/90, $y0+35, -fill => 'red', -text => 'an der jeweiligen GPS-Sat-Kurve');

   while (<FH1>)
      {
# gpsd: Satellite Tracking Status: Ch  0 PRN   6 Res 0 Acq 1 Eph  2 SNR 50.2 LMT 8ab35, Wed Jan  7 14:48:37 1970 El 70.4 Az 162.2
# gpsd: Satellite Tracking Status: Ch  0 PRN  11 Res 0 Acq 1 Eph  2 SNR 47.3 LMT e0bf, Thu Jan  1 16:58:55 1970 El 61.5 Az 280.5
#					 Messpunkt
#         Sun   Jul    2   09 : 54 : 15     1872 Lux
#          1     2     3    4    5    6       7       $Index
#	if ( /^(...) (...) (..) (..):(..):(..)   (\d*).*/ ) 
	#if ( /^gpsd: Satellite Tracking Status: Ch.*PRN  ( *\d*).*SNR (.*\.).*El (....) Az (...\..).*/ )
	if ( /^gpsd: Satellite Tracking Status: Ch.*PRN  ( *\d*).*SNR (.*\.).*(\d) (..):(..):(..).*El (....) Az (...\..).*/ )
	#if ( /^gpsd: Satellite Tracking Status: Ch.*PRN  ( *\d*).*SNR (.*\.)()()().*El (....) Az (...\..).*/ )	# fr log-o
	 { 
	 	$iPRN = $1;
		$fSNR = $2;
		$fEl =  $7;
		$fAz =  $8;
		$fElr = $fEl * $fd2r;
		$fAzr = $fAz * $fd2r;

		#$zeit[1] = $monat{$2};
		$zeit[2] = $3;	#Tag
		$zeit[3] = $4;	#Stunde
		$zeit[4] = $5;	#Minute
		$zeit[5] = $6;	#Sekunde

			#for ( $il = 0; $il < 35; $il++ ) {
			#	print " $Dop[$il]";
			#	#print "il= $il, Dop-il= $Dop[$il] ";
			#}
			#print "\n";

		
		if ($start1) { $c->createText( 50, 20 , -fill => 'black', -text => "Start $towday[int($zeit[2])] $4:$5:$6" );  }
		$start1 = 0;
				
		$cx = $x0 + $m*cos(-$fAzr)*(1-$fEl/90);	# Koordinaten aus Azimuth und Elevation ausrechnen
		$cy = $y0 - $m*sin(-$fAzr)*(1-$fEl/90);
	
		$b = 0;
		if ( ($zeit[4] < 1) and ( $zeit[5] < 5 )  ) { $b = 1  };		# true if volle Stunde

		#print " fSNR=", $fSNR, " iPRN=", $iPRN, "\n";
                #print "fSNR = $fSNR\n";
                #print "colorin= ", int($fSNR/1.74), "\n";
                #print "mkcolorout= ", mkcolor(int($fSNR/1.74)), "\n" ;
                #$co = mkcolor(int($fSNR/2));		# color(SNR)
		$co = mkcolor(int(15 + $Dop[$iPRN]/300));	# color/grey(Doppler/level)
                #print "dollar co= $co\n";

		if ( ($fSNR > 1.) and $b ) { $c->createText($cx, $cy-4, -fill => 'red', -text => $1 );  } 
		#if ( ($fSNR > 1.) and not $b ) 
                   #{ $c->createOval($cx, $cy, $cx+ ($fSNR-15)/$interv , $cy+ ($fSNR-15)/$interv , -fill => $co );  }
                #if ( ($fSNR > 1.) and not $b ) { $c->createOval($cx, $cy, $cx+ ($fSNR-15)/$interv , $cy+ ($fSNR-15)/$interv , -fill => 'black');  }

		#if ( ($fSNR > 1.) and not $b ) { $c->createOval($cx, $cy, $cx+ ($fEl)/$interv , $cy+ ($fEl)/$interv , -fill => 'black');  }

		#if ( ($fSNR > 1.) and not $b ) { $c->createText($cx, $cy, -fill => 'black', -text => '.', -width => $fSNR/$interv + 1 );  } 
		#$c->createText($cx, $cy, -fill => 'black', -text => '.' );	# fr log-o
                $c->createText($cx, $cy, -fill => $co, -text => '.' );



		#print "PRN=", $iPRN,  " SNR=", $fSNR, " cx=", int($cx), " cy=", int($cy)," zeit=", $zeit[3], ":", $zeit[4], ":", $zeit[5], " b=", $b, "\n";
		#$c->createText($j-1000, 20, -fill => 'blue', -text => $7 ); 
	  	#$c->createLine( $lx, $ly, $cx, $cy , -fill => 'black', -width => 1 );

	 };  	# end if line found

# if ( /^gpsd: Satellite Tracking Status: Ch.*PRN  ( *\d*).*SNR (.*\.).*(\d) (..):(..):(..).*El (....) Az (...\..).*/ )
# Doppler |gpsd: Raw Measurement Data 23 Lev 49.500000 Pha 8032.583984 Dop -805.107422 Tow 491698.000000
	if ( /^gpsd: Raw Measurement Data (\d*) Lev.*Dop (.*) Tow.*/ )
	{
		$PRN = $1;
		$fDop = $2;
		$Dop[$PRN] = $fDop;
		#print "Dop $fDop\n";
		#print "PRN $PRN, Dop $fDop\n";
	}	# end Doppler

# gpsd: GPS Time 491700 1567 15 22.1.2010 16:35:0
	if ( /^gpsd: GPS Time .*(\d*)\.(\d*)\.(\d*) (\d*):(\d*):(\d*).*/ )
	{
		
		#print "PRN $PRN, Dop $fDop\n";
	}	# end GPS Time

      }	# ussere while Klammer
   $c->createText( 50, 30 , -fill => 'black', -text => "End $towday[int($zeit[2])] $zeit[3]:$zeit[4]:$zeit[5]" );
   close(FH1);
}   # end procfiles

